namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            double hue        = 3.3d;
            double saturation = 0.4d;
            double value      = 0.9d;

            ColorPicker colorPicker = new ColorPicker(400);

            Image colorPickerImage = colorPicker.DrawImage(hue, saturation, value);

            using(Graphics imageGraphics = Graphics.FromImage(colorPickerImage))
            {
                Pen pen = value < 0.5d ? Pens.White : Pens.Black;

                Point2D wheelPoint = colorPicker.GetWheelPosition(hue);

                imageGraphics.DrawEllipse(pen, (float)wheelPoint.X - 5, (float)wheelPoint.Y - 5, 10, 10);

                Point2D trianglePoint = colorPicker.GetTrianglePosition(saturation, value);

                imageGraphics.DrawEllipse(pen, (float)trianglePoint.X - 5, (float)trianglePoint.Y - 5, 10, 10);
            }

            this.pictureBox.Image = colorPickerImage;
        }

        #endregion
    }
}